Merge branch 'upstream'
[automated-distro-installer] / wrt-setup-local
1 #!/bin/bash
2 # Copyright (C) 2016 Ian Kelling
3
4 # This program is free software; you can redistribute it and/or
5 # modify it under the terms of the GNU General Public License
6 # as published by the Free Software Foundation; either version 2
7 # of the License, or (at your option) any later version.
8
9 # This program is distributed in the hope that it will be useful,
10 # but WITHOUT ANY WARRANTY; without even the implied warranty of
11 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
12 # GNU General Public License for more details.
13
14 # You should have received a copy of the GNU General Public License
15 # along with this program; if not, write to the Free Software
16 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
17
18
19 f=/usr/local/lib/bash-bear;test -r $f || { echo "error: $0 no $f" >&2;exit 1;}; . $f
20
21 usage() {
22 cat <<EOF
23 usage: ${0##*/} [-h] [-t 2|3|test|client] [-m WIRELESS_MAC] [hostname]
24 setup my router in general: dhcp, dns, etc.
25
26 Type 2 or 3 is for setting up a backup device, there are two kinds so
27 that you can switch the main device to a backup, then a backup to the
28 main. Type test is for setting up a testing device.
29
30 Passing an empty string for WIRELESS_MAC, or if none is defined in the
31 secrets file, will cause the device's native mac to be used.
32
33 EOF
34
35 exit $1
36 }
37
38
39
40 zblock=false
41 if [[ -e /root/zblock ]]; then
42 zblock=true
43 fi
44
45 dnsmasq_restart=false
46 unbound_restart=false
47 firewall_restart=false
48 dev2=false
49 test=false
50 client=false
51 ap=false
52 libremanage_host=wrt2
53 lanip=1
54 while getopts hm:t:yz opt; do
55 case $opt in
56 h) usage ;;
57 t)
58 case $2 in
59 2|3)
60 dev2=true
61 libremanage_host=$hostname
62 ;;&
63 2)
64 lanip=4
65 hostname=wrt2
66 ;;
67 3)
68 lanip=14
69 hostname=wrt3
70 ;;
71 test)
72 test=true
73 ;;
74 client)
75 client=true
76 ;;
77 ap)
78 ap=true
79 lanip=53
80 hostname=cmcap
81 ;;
82 *) echo "$0: unexpected arg to -t: $*" >&2; usage 1 ;;
83 esac
84 ;;
85 y)
86 zblock=false
87 rm -f /root/zblock
88 ;;
89 z)
90 zblock=true
91 touch /root/zblock
92 ;;
93 m) mac=$OPTARG ;;
94 *) echo "$0: Internal error! unexpected args: $*" >&2 ; usage 1 ;;
95 esac
96 done
97 shift "$((OPTIND-1))" # Discard the options and sentinel --
98
99 if [[ $1 ]]; then
100 h=$1
101 elif [[ $hostname ]]; then
102 h=$hostname
103 else
104 h=cmc
105 fi
106
107 if [[ ! $hostname ]]; then
108 hostname=$h
109 fi
110
111
112 secrets=false
113 if [[ -e /root/router-secrets ]]; then
114 secrets=true
115 source /root/router-secrets
116 fi
117
118 if [[ ! $mac ]] && ! $test && $secrets; then
119 # if we wanted to increment it
120 #mac=${mac:0: -1}$((${mac: -1} + 2))
121 mac=${rwmac[$h]}
122 fi
123
124 if (( $# != 0 )); then
125 usage 1
126 fi
127
128
129 macpre=${mac:0: -1}
130 macsuf=${mac: -1}
131
132
133 p_updated=false
134 pmirror() {
135 if $p_updated; then
136 return
137 fi
138 # background: upgrading all packages is not recommended because it
139 # doesn't go into the firmware. build new firmware if you want
140 # lots of upgrades. I think /tmp/opkg-lists is a pre openwrt 14 location.
141 f=(/var/opkg-lists/*)
142 if ! (( $(date -r $f +%s) + 60*60*24 > $(date +%s) )); then
143 if ! opkg update; then
144 echo "$0: warning: opkg update failed" >&2
145 fi
146 p_updated=true
147 fi
148 }
149
150 pi() {
151 to_install=()
152 for p in "$@"; do
153 pname=${p##*/}
154 pname=${pname%%_*}
155 if [[ ! $(opkg list-installed "$pname") ]]; then
156 to_install+=($p)
157 pmirror
158 fi
159 done
160 if [[ $to_install ]]; then
161 opkg install ${to_install[@]}
162 fi
163 }
164
165 v() {
166 printf "+ %s\n" "$*"
167 "$@"
168 }
169
170 ######### uci example:#######
171 # # https://wiki.openwrt.org/doc/uci
172 # wan_index=$(uci show firewall | sed -rn 's/firewall\.@zone\[([0-9])+\]\.name=wan/\1/p')
173 # wan="firewall.@zone[$wan_index]"
174 # if [[ $(uci get firewall.@forwarding[0].dest) != $forward_dest ]]; then
175 # # default is wan
176 # v uci set firewall.@forwarding[0].dest=$forward_dest
177 # uci commit firewall
178 # firewall_restart=true
179 # fi
180 ####### end uci example #####
181
182 uset() {
183 printf "+ uset %s\n" "$*"
184 local key="$1"
185 local val="$2"
186 local service="${key%%.*}"
187 restart_var=${service}_restart
188 if [[ ! ${!restart_var} ]]; then
189 eval $restart_var=false
190 fi
191 if [[ $(uci get "$key") != "$val" ]]; then
192 v uci set "$key"="$val"
193 uci commit $service
194 eval $restart_var=true
195 fi
196 }
197
198 udel() {
199 printf "+ udel %s\n" "$*"
200 local key="$1"
201 local val="$2"
202 local service="${key%%.*}"
203 restart_var=${service}_restart
204 if [[ ! ${!restart_var} ]]; then
205 eval $restart_var=false
206 fi
207 if uci get "$key" &>/dev/null; then
208 v uci set "$key"="$val"
209 uci commit $service
210 eval $restart_var=true
211 fi
212 }
213 cedit() {
214 v command cedit -v "$@"
215 }
216
217
218 ### network config
219 ###
220 lan=10.0.0.0
221 if $test; then
222 lan=10.1.0.0
223 elif [[ $hostname == cmc || $hostname == cmcap ]]; then
224 lan=10.2.0.0
225 elif $client; then
226 lan=10.3.0.0
227 fi
228
229 if $test; then
230 ssid="gnuv3"
231 elif $secrets; then
232 ssid=${rssid[$h]}
233 fi
234
235 : ${ssid:=librecmc}
236
237
238 if $secrets; then
239 key=${rkey[$h]}
240 fi
241 : ${key:=pictionary49}
242
243 mask=255.255.0.0
244 cidr=16
245 l=${lan%.0}
246
247 # why did we lock this? i don't know
248 #passwd -l root ||: #already locked fails
249
250 sed -ibak '/^root:/d' /etc/shadow
251 # /root/router created by manually running passwd then copying the resulting
252 # line. We have no mkpasswd on wrt/librecmc, then we scp it in.
253 cat /root/router >>/etc/shadow
254 # otherwise, serial console gets root login with no password
255 uset system.@system[0].ttylogin 1
256
257
258
259 cat >/usr/bin/archlike-pxe-mount <<'EOFOUTER'
260 #!/bin/bash
261 # symlinks are collapsed for nfs mount points, so use a bind mount.
262 # tried putting this in /etc/config/fstab,
263 # then doing block mount, it didn't work. This doesn't persist across reboots,
264 # todo: figure that out
265 rm -f /etc/fstab
266 for d in /run/{arch,parabola}iso/bootmnt; do
267 cat >>/etc/fstab <<EOF
268 /mnt/usb/tftpboot $d none bind 0 0
269 EOF
270 mount | grep $d &>/dev/null || mount $d
271 done
272 /etc/init.d/nfsd restart
273 EOFOUTER
274 chmod +x /usr/bin/archlike-pxe-mount
275
276 sed -i '/^root:/s,/bin/ash$,/bin/bash,' /etc/passwd
277
278
279
280 uset dropbear.@dropbear[0].PasswordAuth 0
281 uset dropbear.@dropbear[0].RootPasswordAuth 0
282 uset dropbear.@dropbear[0].Port 2220
283 if ! cmp -s /root/dropbear_rsa_host_key /etc/dropbear/dropbear_rsa_host_key; then
284 cp /root/dropbear_rsa_host_key /etc/dropbear/dropbear_rsa_host_key
285 dropbear_restart=true
286 fi
287
288 if $dropbear_restart; then
289 v /etc/init.d/dropbear restart
290 fi
291
292
293 uset network.lan.ipaddr $l.$lanip
294 uset network.lan.netmask $mask
295 if $dev2 || $client || $ap; then
296 if $dev2 || $ap; then
297 uset network.lan.gateway $l.1
298 uset network.wan.proto none
299 uset network.wan6.proto none
300 fi
301 /etc/init.d/dnsmasq stop
302 /etc/init.d/dnsmasq disable
303 /etc/init.d/odhcpd stop
304 /etc/init.d/odhcpd disable
305 rm -f /etc/resolv.conf
306 if $ap; then
307 cat >/etc/resolv.conf <<EOF
308 nameserver $l.1
309 EOF
310 else
311 cat >/etc/resolv.conf <<'EOF'
312 nameserver 8.8.8.8
313 nameserver 8.8.4.4
314 EOF
315 fi
316
317 # things i tried to keep dnsmasq running but not enabled except local dns,
318 # but it didnt work right and i dont need it anyways.
319 # uset dhcp.wan.ignore $dev2 # default is false
320 # uset dhcp.lan.ignore $dev2 # default is false
321 # uset dhcp.@dnsmasq[0].interface lo
322 # uset dhcp.@dnsmasq[0].localuse 0
323 # uset dhcp.@dnsmasq[0].resolvfile /etc/dnsmasq.conf
324 # uset dhcp.@dnsmasq[0].noresolv 1
325 # todo: populate /etc/resolv.conf with a static value
326
327 else
328 # these are the defaults
329
330 # this is not needed unless switching from the above condition.
331 # disabling just to debug
332 #uset network.lan.gateway ''
333
334 uset network.wan.proto dhcp
335 uset network.wan6.proto dhcpv6
336 /etc/init.d/dnsmasq start
337 # todo: figure out why this returns 1
338 /etc/init.d/dnsmasq enable ||:
339 /etc/init.d/odhcpd start
340 /etc/init.d/odhcpd enable
341 fi
342
343 wireless_restart=false
344
345 if $client; then
346 uset wireless.default_radio0.network 'wwan'
347 uset wireless.default_radio0.ssid ${rclientssid[$h]}
348 uset wireless.default_radio0.encryption 'psk2'
349 uset wireless.default_radio0.device 'radio0'
350 uset wireless.default_radio0.mode 'sta'
351 uset wireless.default_radio0.bssid ${rclientbssid[$h]}
352 # todo: look into whether 5g network is available.
353 uset wireless.default_radio0.key ${rclientkey[$h]}
354 uset wireless.radio0.disabled false
355 uset wireless.radio1.disabled true
356 else
357 # defaults, just reseting in case client config ran
358 uset wireless.default_radio0.network lan
359 uset wireless.default_radio0.mode ap
360 for x in 0 1; do
361 uset wireless.default_radio$x.ssid "$ssid"
362 uset wireless.default_radio$x.key $key
363 uset wireless.default_radio$x.encryption psk2
364 if [[ $mac ]]; then
365 uset wireless.default_radio$x.macaddr $macpre$((macsuf + 2*x))
366 fi
367 # disable/enable. secondary device has wireless disabled
368 uset wireless.radio$x.disabled $dev2
369 done
370 fi
371
372 if grep '^OPENWRT_BOARD="mvebu/cortexa9"' /etc/os-release &>/dev/null; then
373 # todo, I also enabled irqbalance, didnt script it though
374 # https://forum.openwrt.org/t/wrt1900acs-wifi-issue-after-upgrade-from-19-07-to-21-02-vacuum-cleaner-legacy-rate-support/113311/28
375 cat >/etc/rc.local <<'EOF'
376 echo "0" >> /sys/kernel/debug/ieee80211/phy0/mwlwifi/tx_amsdu
377 echo "0" >> /sys/kernel/debug/ieee80211/phy1/mwlwifi/tx_amsdu
378 exit 0
379 EOF
380 chmod +x /etc/rc.local
381 /etc/rc.local
382 uset wireless.radio0.disassoc_low_ack 0
383 uset wireless.radio1.disassoc_low_ack 0
384 fi
385
386
387 # found with https://openwrt.org/docs/guide-user/network/wifi/iwchan.
388 # However, the default also chooses 11, and better to let it choose in case things change.
389 # case $HOSTNAME in
390 # cmc)
391 # uset wireless.radio0.channel 11
392 # ;;
393 # esac
394
395
396 # usb, screen, relay are for libremanage
397 # rsync is for brc
398 #
399 # relay package temporarily disabled
400 # /root/relay_1.0-1_mips_24kc.ipk
401 #
402 # note: prometheus-node-exporter-lua-openwrt seems to be a dependency of
403 # prometheus-node-exporter-lua in practice.
404
405 pkgs=(
406 tcpdump
407 screen
408 rsync
409 kmod-usb-storage
410 block-mount
411 kmod-fs-ext4
412 prometheus-node-exporter-lua-openwrt
413 prometheus-node-exporter-lua
414 )
415
416 if ! $ap; then
417 pkgs+=(
418 unbound-daemon
419 unbound-checkconf
420 )
421 fi
422
423 v pi "${pkgs[@]}"
424 # nfs-kernel-server \
425 # openvpn-openssl adblock libusb-compat \
426 # kmod-usb-serial-cp210x kmod-usb-serial-ftdi \
427
428
429 cat >/etc/libremanage.conf <<EOF
430 ${libremanage_host}_type=switch
431 ${libremanage_host}_channel=1
432 EOF
433
434
435
436 v /etc/init.d/fstab enable ||:
437
438 # rebooting makes mounting work, but comparing lsmod,
439 # i'm guessing this will too. todo, test it.
440 # 255 == module already loaded
441 for mod in scsi_mod sd_mod; do v modprobe $mod || [[ $? == 255 ]]; done
442
443 # for archlike pxe. The default settings in the installer expect to find
444 # the NFS at one of these dirs
445 mkdir -p /run/archiso/bootmnt
446 mkdir -p /run/parabolaiso/bootmnt
447
448 # todo: at some later time, i found /mnt/usb not mounted, watch to see if
449 # that is the case after running this or rebooting.
450 # wiki says safe to do in case of fstab changes:
451
452 ## ian: usb broke on old router. if that happens, can just comment this to disable problems
453 # echo | cedit /etc/config/fstab ||:
454 cedit /etc/config/fstab <<EOF || { v block umount; v block mount; }
455 config global automount
456 option from_fstab 1
457 option anon_mount 1
458
459 config mount
460 # /overlay is an / overlay mount for installing extra packages, etc.
461 # https://openwrt.org/docs/guide-user/additional-software/extroot_configuration
462 option target /mnt/usb
463 # option target /overlay
464 option device /dev/sda1
465 option fstype ext4
466 option options rw,async,noatime,nodiratime
467 option enabled 0
468 EOF
469
470
471 # ian: disabled because afaik I don't need it, no benefit.
472 # config global autoswap
473 # option from_fstab 1
474 # option anon_swap 1
475
476 # config swap
477 # option device /dev/sda1
478 # option enabled 1
479
480
481
482
483 # exportfs -ra wont cut it when its the same path, but now a bind mount
484 # todo: restart nfs when nfs is enabled?
485 #cedit /etc/exports <<EOF || v /etc/init.d/nfsd restart ||:
486 cedit /etc/exports <<EOF ||:
487 /mnt/usb $lan/$cidr(rw,no_root_squash,insecure,sync,no_subtree_check)
488 # for arch pxe
489 /run/archiso/bootmnt $lan/$cidr(rw,no_root_squash,insecure,sync,no_subtree_check)
490 /run/parabolaiso/bootmnt $lan/$cidr(rw,no_root_squash,insecure,sync,no_subtree_check)
491 EOF
492
493
494 # todo: enable nfs when we need it only.
495 # v /etc/init.d/portmap start
496 # v /etc/init.d/nfsd start
497 # v /etc/init.d/portmap enable
498 # v /etc/init.d/nfsd enable
499
500
501 cedit /etc/config/prometheus-node-exporter-lua <<'EOF' || /etc/init.d/prometheus-node-exporter-lua restart
502 config prometheus-node-exporter-lua 'main'
503 option listen_ipv6 '0'
504 option listen_interface 'lan'
505 option listen_port '9100
506 EOF
507
508 # default, as of this writing is:
509 # config prometheus-node-exporter-lua 'main'
510 # option listen_interface 'loopback'
511 # option listen_port '9100'
512
513
514
515
516
517 ########## openvpn exampl
518 ########## missing firewall settings for routing lan
519 ########## traffic
520 # v /etc/init.d/openvpn start
521 # v /etc/init.d/openvpn enable
522
523 # # from https://wiki.openwrt.org/doc/uci/firewall
524 # # todo: not sure if /etc/init.d/network needs restarting.
525 # # I did, and I had to restart the vpn afterwards.
526 # # This maps a uci interface to a real interface which is
527 # # managed outside of uci.
528 # cedit /etc/config/network <<'EOF' ||:
529 # config interface 'tun0'
530 # option ifname 'tun0'
531 # option proto 'none'
532 # EOF
533 # cedit /etc/config/openvpn <<'EOF' || v /etc/init.d/openvpn restart
534 # config openvpn my_client_config
535 # option enabled 1
536 # option config /etc/openvpn/client.conf
537 # EOF
538
539 wgip4=10.3.0.1/24
540 wgip6=fdfd::1/64
541 wgport=26000
542
543 network_restart=false
544 if $client; then
545 cedit wific /etc/config/network <<EOF || network_restart=true
546 # https://openwrt.org/docs/guide-user/network/wifi/connect_client_wifi
547 config interface 'wwan'
548 option proto 'dhcp'
549 EOF
550 fi
551
552 cedit /etc/config/network <<EOF || network_restart=true
553 config 'route' 'transmission'
554 option 'interface' 'lan'
555 option 'target' '10.174.0.0'
556 option 'netmask' '255.255.0.0'
557 option 'gateway' '$l.2'
558
559 option interface 'wg0'
560 option proto 'wireguard'
561 option private_key '$(cat /root/wg.key)'
562 option listen_port $wgport
563 list addresses '10.3.0.1/24'
564 list addresses 'fdfd::1/64'
565
566 # tp
567 config wireguard_wg0 'wgclient'
568 option public_key '3q+WJGrm85r59NgeXOIvppxoW4ux/+koSw6Fee1c1TI='
569 option preshared_key '$(cat /root/wg.psk)'
570 list allowed_ips '10.3.0.2/24'
571 list allowed_ips 'fdfd::2/64'
572 EOF
573
574 # Need to reload before we change dnsmasq to give out
575 # static ips in our new range.
576 if $network_restart; then
577 v /etc/init.d/network reload
578 fi
579
580 firewall-cedit() {
581
582 if $client; then
583 cedit wific /etc/config/firewall <<EOF
584 config zone
585 option name wwan
586 option input REJECT
587 option output ACCEPT
588 option forward REJECT
589 option masq 1
590 option mtu_fix 1
591 option network wwan
592 EOF
593 fi
594
595 case $hostname in
596 wrt)
597 cedit host /etc/config/firewall <<EOF
598 config redirect
599 option name ssh
600 option src wan
601 option src_dport 22
602 option dest_ip $l.3
603 option dest lan
604 EOF
605 ;;
606 cmc)
607 cedit host /etc/config/firewall <<EOF
608 config redirect
609 option name ssh
610 option src wan
611 option src_dport 22
612 option dest_ip $l.2
613 option dest lan
614 EOF
615 ;;
616 esac
617
618
619 cedit /etc/config/firewall <<EOF
620 ## begin no external dns for ziva
621 config rule
622 option src lan
623 option src_ip 10.2.0.23
624 option dest_port 53
625 option dest wan
626 option target REJECT
627
628
629 config rule
630 option src wan
631 option dest_ip 10.2.0.23
632 option src_port 53
633 option dest lan
634 option target REJECT
635
636
637 config rule
638 option src lan
639 option src_ip 10.2.0.31
640 option dest_port 53
641 option dest wan
642 option target REJECT
643
644
645 config rule
646 option src wan
647 option dest_ip 10.2.0.31
648 option src_port 53
649 option dest lan
650 option target REJECT
651
652
653 config rule
654 option src lan
655 option src_ip 10.2.0.32
656 option dest_port 53
657 option dest wan
658 option target REJECT
659
660
661 config rule
662 option src wan
663 option dest_ip 10.2.0.32
664 option src_port 53
665 option dest lan
666 option target REJECT
667 ## end no external dns for ziva
668
669
670 config rule
671 option src wan
672 option target ACCEPT
673 option dest_port 22
674
675 config redirect
676 option name promkd
677 option src wan
678 option src_dport 9091
679 option dest_port 9091
680 option dest_ip $l.2
681 option dest lan
682 config rule
683 option src wan
684 option target ACCEPT
685 option dest_port 9091
686
687 config redirect
688 option name sshkd
689 option src wan
690 option src_dport 2202
691 option dest_port 22
692 option dest_ip $l.2
693 option dest lan
694 config rule
695 option src wan
696 option target ACCEPT
697 option dest_port 2202
698
699 # was working on an openvpn server, didn't finish
700 # config redirect
701 # option name vpnkd
702 # option src wan
703 # option src_dport 1196
704 # option dest_port 1196
705 # option dest_ip $l.2
706 # option dest lan
707 # config rule
708 # option src wan
709 # option target ACCEPT
710 # option dest_port 1196
711
712
713 config redirect
714 option name sshkdalt
715 option src wan
716 option src_dport 8989
717 option dest_port 8989
718 option dest_ip $l.2
719 option dest lan
720 config rule
721 option src wan
722 option target ACCEPT
723 option dest_port 8989
724
725
726 config redirect
727 option name sshx2
728 option src wan
729 option src_dport 2205
730 option dest_port 22
731 option dest_ip $l.5
732 option dest lan
733 config rule
734 option src wan
735 option target ACCEPT
736 option dest_port 2205
737
738 config redirect
739 option name sshx3
740 option src wan
741 option src_dport 2207
742 option dest_port 22
743 option dest_ip $l.7
744 option dest lan
745 config rule
746 option src wan
747 option target ACCEPT
748 option dest_port 2207
749
750 config redirect
751 option name sshbb8
752 option src wan
753 option src_dport 2209
754 option dest_port 22
755 option dest_ip $l.32
756 option dest lan
757 config rule
758 option src wan
759 option target ACCEPT
760 option dest_port 2209
761
762
763 config redirect
764 option name sshfrodo
765 option src wan
766 option src_dport 2234
767 option dest_port 34
768 option dest_ip $l.34
769 option dest lan
770 config rule
771 option src wan
772 option target ACCEPT
773 option dest_port 2234
774
775
776 config redirect
777 option name icecast
778 option src wan
779 option src_dport 8000
780 option dest_port 8000
781 option dest_ip $l.2
782 option dest lan
783 config rule
784 option src wan
785 option target ACCEPT
786 option dest_port 8000
787
788 config rule
789 option name sshcmc
790 option src wan
791 option target ACCEPT
792 option dest_port 2220
793
794 config rule
795 option name wg
796 option src wan
797 option target ACCEPT
798 option dest_port $wgport
799 option proto udp
800
801 config redirect
802 option name navidromehttps
803 option src wan
804 option src_dport 4500
805 option dest_port 4500
806 option dest_ip $l.2
807 option dest lan
808 config rule
809 option src wan
810 option target ACCEPT
811 option dest_port 4500
812
813 config redirect
814 option name navidrome
815 option src wan
816 option src_dport 4533
817 option dest_port 4533
818 option dest_ip $l.2
819 option dest lan
820 config rule
821 option src wan
822 option target ACCEPT
823 option dest_port 4533
824
825 # So a client can just have i.b8.nz dns even when they
826 # are on the lan.
827 #config redirect
828 # option name navidromelan
829 # option src lan
830 # option src_dport 4533
831 # option dest_port 4533
832 # option dest_ip $l.2
833 # option dest lan
834
835
836 # config redirect
837 # option name icecast
838 # option src wan
839 # option src_dport 8000
840 # option dest_port 8000
841 # option dest_ip $l.2
842 # option dest lan
843 # config rule
844 # option src wan
845 # option target ACCEPT
846 # option dest_port 8000
847
848 config redirect
849 option name http
850 option src wan
851 option src_dport 80
852 option dest lan
853 option dest_ip $l.7
854 option proto tcp
855 config rule
856 option src wan
857 option target ACCEPT
858 option dest_port 80
859 option proto tcp
860
861 config redirect
862 option name https
863 option src wan
864 option src_dport 443
865 option dest lan
866 option dest_ip $l.7
867 option proto tcp
868 config rule
869 option src wan
870 option target ACCEPT
871 option dest_port 443
872 option proto tcp
873
874 # config redirect
875 # option name httpskd8448
876 # option src wan
877 # option src_dport 8448
878 # option dest lan
879 # option dest_ip $l.2
880 # option proto tcp
881 # config rule
882 # option src wan
883 # option target ACCEPT
884 # option dest_port 8448
885 # option proto tcp
886
887 config redirect
888 option name syncthing
889 option src wan
890 option src_dport 22001
891 option dest_ip $l.8
892 option dest lan
893 config rule
894 option src wan
895 option target ACCEPT
896 option dest_port 22001
897
898
899 #config redirect
900 # option name i2p
901 # option src wan
902 # option src_dport $i2pport
903 # option dest_ip $l.178
904 # option dest lan
905 #config rule
906 # option src wan
907 # option target ACCEPT
908 # option dest_port $i2pport
909
910 config rule
911 option name ssh-ipv6
912 option src wan
913 option dest lan
914 # note, using mac transform, we could allow all traffic to a host like this,
915 # replacing 1 as appropriate
916 #option dest_ip ::111:11ff:fe11:1111/::ffff:ffff:ffff:ffff
917 option dest_port 22
918 option target ACCEPT
919 option family ipv6
920
921 # config rule
922 # option name http-ipv6
923 # option src wan
924 # option dest lan
925 # option dest_port 80
926 # option target ACCEPT
927 # option family ipv6
928
929 # config rule
930 # option name https-ipv6
931 # option src wan
932 # option dest lan
933 # option dest_port 443
934 # option target ACCEPT
935 # option family ipv6
936
937 config rule
938 option name node-exporter
939 option src wan
940 option dest lan
941 option dest_port 9101
942 option target ACCEPT
943 option family ipv6
944
945 config rule
946 option name mail587-ipv6
947 option src wan
948 option dest lan
949 option dest_port 587
950 option target ACCEPT
951 option family ipv6
952
953 EOF
954 }
955 firewall-cedit || firewall_restart=true
956
957 # firewall comment:
958 # not using and in newer wrt, fails, probably due to nonexistent file, error output
959 # on:
960
961 # Reference error: left-hand side expression is not an array or object
962 # In [anonymous function](), file /usr/share/ucode/fw4.uc, line 3137, byte 12:
963 # called from function [arrow function] (/usr/share/ucode/fw4.uc:733:71)
964 # called from function foreach ([C])
965 # called from function [anonymous function] (/usr/share/ucode/fw4.uc:733:72)
966 # called from function render_ruleset (/usr/share/firewall4/main.uc:56:24)
967 # called from anonymous function (/usr/share/firewall4/main.uc:143:29)
968 #
969 # ` if (!inc.enabled) {`
970 # Near here -------^
971 #
972 #
973 # The rendered ruleset contains errors, not doing firewall restart.
974 # /usr/bin/wrt-setup-local:160:error: ""$@"" returned 1
975
976 ## include a file with users custom iptables rules
977 #config include
978 # option path /etc/firewall.user
979 # option type 'restore'
980 # option family 'ipv4'
981
982
983
984 # not using wireguard for now
985 # if ! uci get firewall.@zone[1].network | grep wg0 &>/dev/null; then
986 # # cant mix cedit plus uci
987 # echo | cedit /etc/config/firewall ||:
988 # uci add_list firewall.@zone[1].network=wg0
989 # uci commit firewall
990 # firewall-cedit ||:
991 # firewall_restart=true
992 # fi
993
994
995
996 cedit /etc/hosts <<EOF ||:
997 127.0.1.1 $hostname
998 EOF
999
1000
1001 #mail_host=$(grep -F mail.iankelling.org /etc/hosts | awk '{print $1}')
1002 # if [[ $mail_host ]]; then
1003 # sed -i '/^$mail_host/a mail.iankelling.org' /etc/hosts
1004 # fi
1005
1006
1007 uset dhcp.@dnsmasq[0].domain b8.nz
1008 uset system.@system[0].hostname $hostname
1009 uset dhcp.@dnsmasq[0].local
1010
1011 # uci doesnt seem to have a way to set an empty value,
1012 # if you delete it, it goes back to the default. this seems
1013 # to be a decent workaround.
1014 # todo: setup /etc/resolv.conf to point to 127.0.0.1
1015 # later note: disabled, I dunno why I set this.
1016 # uset dhcp.@dnsmasq[0].resolvfile /dev/null
1017
1018 # if dnsmasq happens to not send out a dns server,
1019 # odhcpd will send one out like this:
1020 # NetworkManager[953]: <info> [1614982580.5192] dhcp6 (wlan0): option dhcp6_name_servers => 'fd58:5801:8e02::1'
1021 # but i dont want ipv6 dns, just keep it simple to ipv4.
1022 # I know my isp doesnt have ipv6 right now,
1023 # so just stop this thing.
1024 # note: tried this, it didn't do anything:
1025 # uset dhcp.@odhcpd[0].dns 10.2.0.1
1026
1027 # iank, disablde while debugging.
1028 #/etc/init.d/odhcpd stop
1029 #/etc/init.d/odhcpd disable
1030
1031 # todo: make the above conditional on which server this is.
1032
1033 ## left commented in case we have ipv6 problems in the future
1034 # avoid errors in log. current isp doesnt have ipv6
1035 #uset unbound.@unbound[0].protocol ip4_only
1036
1037 # todo: im not sure all these are needed, but they all look
1038 # like good options.
1039 # https://blog.cloudflare.com/dns-over-tls-for-openwrt/
1040 # https://gist.github.com/vqiu/7b32d3a19a7a09d32e108d998de166c2
1041 #https://blog.thestateofme.com/2018/04/04/howto-secure-your-dns-with-a-raspberry-pi-unbound-and-cloudflare-1-1-1-1/
1042 #
1043 # # i found that the zone example was having no effect on the config
1044 # # here:
1045 # https://github.com/openwrt/packages/blob/openwrt-19.07/net/unbound/files/README.md
1046 #
1047 # # todo: unbound-control, i'm not sure what the purpose of that thing is, some
1048 # # kind of coordination with dhcp of dnsmasq, but what?
1049 #
1050 # note: for debugging, edit /etc/init.d/unbound, change
1051 # procd_set_param command $PROG -d -c $UB_TOTAL_CONF
1052 # to:
1053 # procd_set_param command $PROG -vvv -d -c $UB_TOTAL_CONF
1054
1055 if ! $ap; then
1056 {
1057 cat <<'EOF'
1058 do-tcp: yes
1059 prefetch: yes
1060 qname-minimisation: yes
1061 rrset-roundrobin: yes
1062 use-caps-for-id: yes
1063 do-ip6: no
1064 private-domain: b8.nz
1065 local-zone: "10.in-addr.arpa." transparent
1066 access-control-view: 10.2.0.31/32 "youtube"
1067 EOF
1068
1069 if $zblock; then
1070 cat <<'EOF'
1071 # no sy until that dongle is used by ziva
1072
1073 # syw
1074 #access-control-view: 10.2.0.7/32 "youtube"
1075 # bow
1076 access-control-view: 10.2.0.29/32 "youtube"
1077 # samsungtab
1078 access-control-view: 10.2.0.32/32 "youtube"
1079 EOF
1080 fi
1081 } | cedit /etc/unbound/unbound_srv.conf || unbound_restart=true
1082
1083
1084 # dns based blocking vs ip based. with ip, same
1085 # server can have multiple domains. in dns,
1086 # you have to make sure clients to use the local dns.
1087 # https dns will need to be blocked by ip in
1088 # order to be comprehensive
1089
1090
1091 cedit /etc/unbound/unbound_ext.conf <<EOF || unbound_restart=true
1092
1093 $(. /root/ptr-data)
1094
1095 local-data-ptr: "10.2.0.1 cmc.b8.nz"
1096
1097 local-data-ptr: "10.174.2.2 transmission.b8.nz"
1098 local-data-ptr: "10.173.8.1 defaultnn.b8.nz"
1099 local-data-ptr: "10.173.8.2 nn.b8.nz"
1100
1101 forward-zone:
1102 name: "."
1103 # forward-addr: 8.8.8.8
1104 # forward-addr: 8.8.8.8
1105
1106 # ssl disabled due to this error:
1107 #Sat Dec 24 03:34:44 2022 daemon.err unbound: [6568:0] error: ssl handshake failed crypto error:1416F086:SSL routines:tls_process_server_certificate:certificate verify failed
1108 #Sat Dec 24 03:34:44 2022 daemon.notice unbound: [6568:0] notice: ssl handshake failed 1.0.0.3 port 853
1109 # on OPENWRT_RELEASE="OpenWrt SNAPSHOT r18639-f5865452ac"
1110 # from about feb 2022
1111
1112 # https://developers.cloudflare.com/1.1.1.1/1.1.1.1-for-families/setup-instructions/dns-over-https
1113 # forward-addr: 1.1.1.3@853#family.cloudflare-dns.com
1114 # forward-addr: 1.0.0.3@853#family.cloudflare-dns.com
1115 # forward-ssl-upstream: yes
1116 forward-first: no
1117 forward-addr: 1.1.1.3
1118 forward-addr: 1.0.0.3
1119
1120 view:
1121 name: "youtube"
1122 local-zone: "googlevideo.com." refuse
1123 local-zone: "video.google.com." refuse
1124 local-zone: "youtu.be." refuse
1125 local-zone: "youtube-nocookie.com." refuse
1126 local-zone: "youtube-ui.l.google.com." refuse
1127 local-zone: "youtube.com." refuse
1128 local-zone: "youtube.googleapis.com." refuse
1129 local-zone: "youtubeeducation.com." refuse
1130 local-zone: "youtubei.googleapis.com." refuse
1131 local-zone: "yt3.ggpht.com." refuse
1132 local-zone: "youtubekids.com." refuse
1133 # try global if no match in view
1134 view-first: yes
1135 EOF
1136
1137
1138 if $unbound_restart; then
1139 /etc/init.d/unbound restart
1140 if ! unbound-checkconf; then
1141 echo $0: error: unbound-checkconf failed >&2
1142 exit 1
1143 fi
1144 fi
1145 fi # end if $ap
1146
1147 # # disabled for now. i want to selectively enable it
1148 # # for specific hosts.
1149 # if [[ $(uci get adblock.global.adb_enabled) != 0 ]]; then
1150 # v uci set adblock.global.adb_enabled=0
1151 # uci commit adblock
1152 # /etc/init.d/adblock restart
1153 # fi
1154 # # https://github.com/openwrt/packages/tree/master/net/adblock/files
1155 # cat >/etc/crontabs/root <<'EOF'
1156 # 0 06 * * * /etc/init.d/adblock reload
1157 # EOF
1158
1159
1160 # useful: http://wiki.openwrt.org/doc/howto/dhcp.dnsmasq
1161
1162 # sometimes /mnt/usb fails, cuz it's just a flash drive,
1163 # so make sure we have this dir or else dnsmasq will fail
1164 # to start.
1165 mkdir -p /mnt/usb/tftpboot
1166 cedit /etc/dnsmasq.conf <<EOF || dnsmasq_restart=true
1167
1168 # no dns
1169 port=0
1170 server=/b8.nz/#
1171 ptr-record=1.0.2.10.in-addr.arpa.,cmc.b8.nz
1172
1173 # generated with host-info-update
1174 $(. /root/dnsmasq-data)
1175
1176 # https://ret2got.wordpress.com/2018/01/19/how-your-ethereum-can-be-stolen-using-dns-rebinding/
1177 stop-dns-rebind
1178 rebind-domain-ok=b8.nz
1179
1180 # This says the ip of dns server.
1181 # It is default if dnsmasq is doing dns, otherwise, we have to specify it.
1182 # To see it in action, I ran this from a client machine:
1183 # sudo dhcpcd -o domain_name_servers -T
1184 dhcp-option=option:dns-server,$l.1
1185
1186 # use this when doing fai to get the right timezone, its nfsroot is
1187 # setup to use this dhcp option only and call ntpdate.
1188 # generate ips with:
1189 # for h in 0.ubuntu.pool.ntp.org 1.ubuntu.pool.ntp.org ntp.ubuntu.com; do host -t a $h | awk '{print $NF}'; done | while read -r l; do printf ,$l; done
1190 dhcp-option=option:ntp-server,188.165.3.28,202.12.97.45,91.236.251.13,50.205.244.23,78.30.254.80,31.131.0.123,202.65.114.202,94.228.220.14,185.125.190.57,185.125.190.58,91.189.91.157,185.125.190.56,91.189.94.4
1191
1192
1193 # results from googling around dnsmasq optimizations
1194 # about 50k in memory. router has 62 megs.
1195 # in a browsing session, I probably won't ever do 5000 lookups
1196 # before the ttl expiration or whatever does expiration.
1197 cache-size=10000
1198
1199 # ask all servers, use the one which responds first.
1200 # http://ma.ttwagner.com/make-dns-fly-with-dnsmasq-all-servers/
1201 all-servers
1202
1203 # namebench benchmarks dns servers. google's dns was only
1204 # slightly less fast than some others, and I trust it more
1205 # to give accurate results, stay relatively fast, and
1206 # not do anythin too malicious, so just use that.
1207 # download namebench and run it like this:
1208 # for x in all regional isp global preferred nearby; do ./namebench.py -s \$x -c US -i firefox -m weighted -J 10 -w; echo \$x; hr; done
1209 # google
1210 server=1.1.1.3
1211 server=1.0.0.3
1212 server=2606:4700:4700::1113
1213 server=2606:4700:4700::1003
1214
1215 server=10.2.0.1
1216 # server=8.8.4.4
1217 # server=8.8.8.8
1218 # server=2001:4860:4860::8888
1219 # server=2001:4860:4860::8844
1220
1221
1222 # to fixup existin ips, on the client you can do
1223 # sudo dhclient -r; sudo dhclient <interface-name>
1224 # or on cmc,
1225 # /etc/init.d/dnsmasq stop
1226 # vi /tmp/dhcp.leases
1227 # /etc/init.d/dnsmasq start
1228
1229
1230 # default dhcp range is 100-150
1231
1232 # template
1233 # dhcp-host=,$l.,
1234
1235 # pxe tftpboot for arch-like. todo: openwrt snapshot from 2022-01, it cant
1236 # access /mnt/usb/tftpboot due to ujail sandbox
1237 #enable-tftp=br-lan
1238 #tftp-root=/mnt/usb/tftpboot
1239 #tftp-root=/var/run/dnsmasq/tftpboot
1240
1241
1242 dhcp-optsfile=/var/run/dnsmasq/dhcpopts.conf
1243
1244 # for debugging dhcp
1245 #log-queries=extra
1246 EOF
1247
1248
1249 if $dnsmasq_restart && ! $dev2 && ! $ap; then
1250 # todo: can our ptr records be put in /etc/hosts?
1251 # eg: user normal /etc/hosts records, and they wont be used for A resolution
1252 # due to the other settings, but will be used for ptr? then maybe
1253 # we dont have to restart dnsmasq for a dns update?
1254 #
1255 # interesing link:
1256 # https://www.redpill-linpro.com/techblog/2019/08/27/evaluating-local-dnssec-validators.html#toggling-dnssec-validation-1
1257 # we could turn on dnssec validation when wrt gets dnsmasq > 2.80. currently at 2.80.
1258 # also we can turn off dnssec in systemd-resolved if we know the router is doing it.
1259 #
1260 # Also, reload of dnsmasq seems to break things, wifi
1261 # clients were not getting internet connectivity.
1262
1263 v /etc/init.d/dnsmasq restart
1264 fi
1265
1266 if $ap; then
1267 v /etc/init.d/firewall disable
1268 v /etc/init.d/firewall stop
1269 elif $firewall_restart; then
1270 v /etc/init.d/firewall restart
1271 fi
1272
1273 ## turn off luci
1274 # if already stopped, gives error we want to ignore
1275 /etc/init.d/uhttpd stop |& sed '1{/^Command failed/d}'
1276 /etc/init.d/uhttpd disable |& sed '1{/^Command failed/d}'
1277
1278 # this may just restart the network and take care of the network_restart below.
1279 if $wireless_restart; then
1280 v wifi
1281 fi
1282
1283 # todo: we should catch errors and still run this if needed
1284 if $network_restart; then
1285 reboot
1286 fi
1287
1288 v exit 0